/*
 ABOT roaming with PING))) 
*/

#include "abdrive.h"
#include "simpletools.h"                        // Include simpletools header
#include "servo.h"                              // Include servo header
#include "ping.h"                               // Include ping header


int adeg[36];                                  // 36 degree updates/elements by Front Servo
int adist[36];                                 // 36 distance elements by PING)))

int main()                                      // Main function
{ 
  
  int count = 0;
  int location = 0;
  int turndeg = 0;
  int left = 0;
  int right = 0;
  float rad = 0;
  float circum = 0;
  float r = 105.8;
  float pertick = 3.25;
  int ticks;
  
  drive_ramp(64, 64);                           // Ramp forward 64ticks/s
  pause(4800);                                  // Ramp forward for 4.8s for 1m
  drive_ramp(0, 0);                             // Stop
  
  
  servo_setramp(16, 40);                        // Ramp up the PING))) servo to 40 deg per update, faster moving servo to 0 deg
  servo_angle(16, 0);                           // Starts PING))) servo to 0 degree
  pause(1000);                                  // Allow 1 second to get there
  servo_setramp(16, 10);                        // Set back PING))) servo to ramp down to 10 deg per update                    


  for(int deg = 0; deg <= 1800;  deg += 50)     // use for instead of while for PING))) servo degree update
  {
    servo_angle(16, deg);                       // Ramps PING))) servo from 0 to 180 deg
    pause(150);                                 // Stay still for 0.15 sec after each time PING))) servo moves for ABOT to update PING)))
    
    adeg[count] = deg/10;
    
    
    
    adist[count] = ping_cm(0);                  // Get cm distance from Ping)))
    
    print("distance is = %d\n", adist[count]);  // Display distance
    print("degree is = %d\n", adeg[count]);
    pause(100);                                 // Wait 0.1 second
    
    count += 1;
       
   }
   
  
  
  int max = adist[0];   
  
  for (count = 1; count < 36; count++)
  {
    
    if (adist[count] > max)
    {
      max = adist[count];
       
      location = count; 
        
    }      
       
  } 
  
  print("maximum distance is %d and angle is %d\n", max, adeg[location]); 
  
   
  
  /*if(adeg[location] < 90)
  {
   turndeg = 90 - adeg[location];
   rad = turndeg * PI / 180;
   circum = rad * r;
   ticks = circum / pertick;
   left = ticks/2;
   right = ticks/2;
   
   //drive_goto(left, -right);
      
  } 
  
  
  
 
  
  else if(adeg[location] > 90)
  {
   turndeg = adeg[location] - 90; 
   rad = turndeg * PI / 180;
   circum = rad * r;
   ticks = circum / pertick;
   left = ticks/2;
   right = ticks/2;
   
   drive_goto(-left, right); 
   
  }
  
  
  else if(adeg[location] == 90)
  {
   drive_ramp(0, 0);                            // Stop 
   
  }           
  
  */    
  
  servo_setramp(16, 40);                        // Reset PING))) servo to 40 deg per update 
  servo_angle(16, 900);                         // Reset PING))) servo to 90 degree
  
  
                                              
 
}

